%Golomb-Lineale (Spektrum der Wissenschaft 2/86)

golomb(N, L, M):-
	L in 0..M,
	Distances in 1..M,
	length(L, N),
	reorder(L,L1),
	first(L, 0),
	last(L, Max),
	ordered(L),		%constraint to reduce symmetries
	diffs_of_two(L,Distances),
%	red(N,Distances),
	alldifferent(Distances),
%	N2 is N/2, nth(N2, L, Middle), 2*Middle #=< Max,
	first(Distances,FirstDist),
	last(Distances,LastDist),
	FirstDist #> LastDist,	%constraint to reduce symmetries
%	minimize(labeling(L),Max).
	Low is (N-1)*N/2,
	between(Max,Low,M),	%assumption: between generates from lo to hi
	labeling(L1,[size,constraints]).

diffs_of_two([],[]).
diffs_of_two([H|T],S):- append(S1,S2,S), diffs_of(T,H,S1), diffs_of_two(T,S2).

diffs_of(L,X,D):-
	diffs_of(L,X,D,[1,3,6,11,17,25,34,44,55,72,85,106,114,133,154]).

diffs_of([],_,[],_).
diffs_of([H|T],X,[D|DT],[M|MT]):-  D#>=M, pluslook(X,D,H), diffs_of(T,X,DT,MT).

red(N,D):- red(1,N,D).

red(M,M,D).
red(I,M,D):- I<M, plus(I,1,I1), red(I1,I,M,D), red(I1,M,D).

red(M1,I,M,D):- plus(M,1,M1).
red(J,I,M,D):- J=<M, plus(J,1,J1), plus(I,1,I1), red(I1,J,I,M,D), red(J1,I,M,D).

red(J,J,I,M,D).
red(K,J,I,M,D):- K<J,
	pos(I,J,M,P3),
	pos(K,J,M,P2),
	pos(I,K,M,P1),
	nth(P1,D,D1), nth(P2,D,D2), nth(P3,D,D3), 
	$pluslook2(D1,D2,D3), plus(K,1,K1), red(K1,J,I,M,D).

pos(I,J,M,P):-
%	P is (I-1)*(N-1)-(I-1)*(I-2)/2+J-I.
	times(M,2,M2),plus(M2I,I,M2),plus(I1,1,I),times(I1,M2I,MI),times(O,2,MI),plus(O,J,OJ),plus(P,I,OJ).

%diffs_of_two([],[]).
%diffs_of_two([H|T],S):- append(S1,S2,S), diffs_of(T,H,S1), diffs_of_two(T,S2).

%diffs_of([],_,[]).
%diffs_of([H|T],X,[S|ST]):- pluslook(X,S,H), diffs_of(T,X,ST).

ordered([]).
ordered([_]).
ordered([X,Y|T]):- X#<Y, ordered([Y|T]).

between(X,L,H):- H >= L, varin(X,L..H), indomain(X).

%e.g. reorder([1,2,3,4,5,6,7],[4,2,6,1,5,3,7])
reorder([],[]).
reorder(L1,[M|L2]):-
	length(L1,N),
	N2 is N/2,
	length(F,N2),
	append(F, [M|R], L1),
	reorder(F,F1),
	reorder(R,R1),
	interleave(F1,R1,L2).

interleave([],[],[]).
interleave([],[H|T],[H|T]).
interleave([H|T],[],[H|T]).
interleave([X|T1],[Y|T2],[X,Y|T3]):- interleave(T1,T2,T3).


labeling1([]).
labeling1([[]|T]):-labeling1(T).
labeling1([L|T]):- deleteff(Var,L,R,[size]), indomain(Var), labeling1([R|T]).

reorderl([],[]).
reorderl(L1,[[M]|L2]):-
	length(L1,N),
	N2 is N/2,
	length(F,N2),
	append(F, [M|R], L1),
	reorderl(F,F1),
	reorderl(R,R1),
	mapappend(F1,R1,L2).

mapappend([],[],[]).
mapappend([],[H|T],[H|T]).
mapappend([H|T],[],[H|T]).
mapappend([X|T1],[Y|T2],[XY|T3]):- append(X,Y,XY), mapappend(T1,T2,T3).

