% 8-queens - what else is there to say
%forward checking

queens(N,L):-
	length(L,N),
	inlist(L,1..N),
	safe(L),
	labeling(L).

delay length(nonvar,any).
delay length(any,nonvar).
length([],0).
length([X|Y],N):- less(0,N), plus(N1,1,N), length(Y,N).

delay less(nonvar,nonvar).
less(X,Y):- X<Y.

inlist([],_).
inlist([X|Y],D):- X in D, inlist(Y,D).

labeling([]).
labeling([X|Y]):- indomain(X), labeling(Y).

indomain(X):- domain(X,L), member(X,L).

member(X,[X|_]).
member(X,[_|Y]):- member(X,Y).

%delay safe(nonvar).
safe([]).
safe([X|Xs]):-
	noattack(X,Xs),
	safe(Xs).

noattack(X,L):- noattack(X,L,1).

%delay noattack(any,nonvar,any).
noattack(X,[],Nb).
noattack(X,[Y|Ys],Nb):-
	noteq(X,Y),
	notsum(X,Nb,Y),
	notsum(Y,Nb,X),
	Nb1 is Nb+1,
	noattack(X,Ys,Nb1).

delay noteq(nonvar,any).
delay noteq(any,nonvar).
noteq(X,Y):- notplus(X,0,Y).

delay notsum(any,nonvar,nonvar).
delay notsum(nonvar,any,nonvar).
delay notsum(nonvar,nonvar,any).
notsum(X,Y,Z):- notplus(X,Y,Z).

%allq:- queens(L),fail.
%allq.

%top:-
%	read(L1,[]),
%	cputime(T0),
%	allq,
%	cputime(T1),
%	Time is T1-T0,
%	write((time=Time)),nl.
